using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace CodeJotter {
    public partial class CodeJotter : UserControl {

        // Handle keypresses going to the scrollbars

        private void VScroller_KeyPress(object sender, KeyPressEventArgs e) {
            this.OnKeyPress(e);
        }

        private void HScroller_KeyPress(object sender, KeyPressEventArgs e) {
            this.OnKeyPress(e);
        }

        // Handle scrolling actions

        private void HScroller_Scroll(object sender, ScrollEventArgs e) {
            UpdateScrollbars();
            InvalidateAll();
        }

        private void VScroller_ValueChanged(object sender, EventArgs e) {
            int OldValue = this.TopmostLine;
            this.TopmostLine = VScroller.Value;
            int Delta = this.TopmostLine - OldValue;

            UpdateScrollbars();
            Invalidate();            
        }

        protected override void OnMouseWheel(MouseEventArgs e) {
            if (CtrlPressed) {
                float NewSize = Math.Max(1, (float)(this.Font.Size + e.Delta / 120));
                this.Font = new Font(this.Font.FontFamily, NewSize, this.Font.Style);
                InvalidateAll();
            } else {
                TopmostLine -= e.Delta / 40;
                UpdateScrollbars();
                Invalidate();
            }
            base.OnMouseWheel(e);
        }
    }
}
